	include "tios.h"
	xdef	_ti89
	xdef	_comment
	xdef	_main
	include "art_macr.asm"

_main	int_off				;detrourne les interruptions...
	jsr tios::OSContrastUp		;monte le contraste
	jsr tios::OSContrastUp
	jsr tios::OSContrastUp
	jsr clr_scr
	move.l #178,d0
	lea $4c00,a0
invert_loop	not.l (a0)+
	dbra d0,invert_loop
	set_font #2
	write_str #25,#8,#0,_comment
	set_font #0
	write_str #15,#30,#1,during
	write_str #20,#37,#1,key1
	write_str #20,#44,#1,key2
	write_str #20,#51,#1,key3
	write_str #15,#65,#1,made1
	write_str #35,#72,#1,made2
	set_font #1
	write_str #42,#85,#1,pressenter
main_loop
	get_key mask6
	btst.b #0,stat_key
	beq exit
	get_key mask1
	btst.b #0,stat_key
	bne main_loop
	cree_les_5_tableaux
loop	move.l timer,old_timer		;sauvegarde le temps pour garder le meme timing
	jsr clr_scr_tmp			;efface l'ecran ou l'on calcul
	affiche_les_5_tableaux_to_tmp	;calcul les pixels et les affiche
	jsr util_process		;affiche l'utilisation processeur
	jsr move_tmp_to_scr		;affiche l'ecran de calcul
	get_key	mask6			;test si esc est appuye
	btst.b #0,stat_key
	beq exit			;si oui on part
	get_key mask1			;test si + ou - est appuye -> change contraste
	btst.b #1,stat_key
	bne no_plus
	jsr tios::OSContrastUp
	bra loop_temp
no_plus	btst.b #2,stat_key
	bne no_moins
	jsr tios::OSContrastDn
	bra loop_temp
no_moins	get_key mask0
	btst.b #0,stat_key
	bne no_up
	sub.l #1,speed
	cmp.l #3,speed
	bne loop_temp
	move.l #4,speed
	bra loop_temp
no_up	btst.b #2,stat_key
	bne loop2
	add.l #1,speed
	cmp.l #105,speed
	bne loop_temp
	move.l #104,speed
loop_temp	move.l timer,old_timer	;temporise pour pouvoir modifier le
	move.l #104,d0
	sub.l speed,d0
	print_d0 #55,#50,#1
	write_str #10,#50,#1,speedstr
loop_temp2	move.l timer,d0		;pour ne pas changer d'un coup
	sub.l old_timer,d0
	cmp.l #40,d0
	bgt loop
	bra loop_temp2
loop2	move.l timer,d0
	sub.l old_timer,d0
	cmp.l speed,d0
	bgt loop
	bra loop2

exit	jsr tios::OSContrastDn		;diminue le contraste
	jsr tios::OSContrastDn
	jsr tios::OSContrastDn
	int_on				;remet les interruptions systemes...
	rts

	include	"art_rout.asm"		;ne pas oublier le fichier der routines

mask0 equ %11111110  ;(up\2nd\donw...)	;les masques clavier utiliser pas get_key
mask1 equ %11111101  ;(Enter\clear...)
mask2 equ %11111011  ;( <- )
mask3 equ %11110111  ;(catalog...)
mask4 equ %11101111  ;(Mode...)
mask5 equ %11011111  ;(Home...)
mask6 equ %10111111  ;(ESC...)
old_int_1	dc.l 0			;sauvegarde des anciennes interruptions
old_int_2	dc.l 0
old_int_3	dc.l 0
old_int_4	dc.l 0
old_int_5	dc.l 0
old_int_6	dc.l 0
old_int_7	dc.l 0
handle_screen	dc.w 0			;l'handle de l'ecran de calcul
adresse_screen	dc.l 0			;son adresse
timer	dc.l 0				;utilse par la nouvelle interruption 1
old_timer dc.l 0
rand_seed	dc.w 0			;utilise par random
speed		dc.l 10			;pour la difference entre timer et old_timer
handle_tableau1	dc.w 0			;les handles de tableaux
handle_tableau2	dc.w 0
handle_tableau3	dc.w 0
handle_tableau4	dc.w 0
handle_tableau5	dc.w 0
adresse_tableau1	dc.l 0		;leurs adresses
adresse_tableau2	dc.l 0
adresse_tableau3	dc.l 0
adresse_tableau4	dc.l 0
adresse_tableau5	dc.l 0

tableau_courant dc.l 0			;valeur de 0 a 2
pixel_courant	dc.l 0			;valeur de 0 a 9
temps_ecoule	dc.w 0
position_initiale_x	dc.w 0		;des varibles utilise temporairement
position_initiale_y	dc.w 0		;pour afficher les tableaux
pixel_courant_afficher	dc.w 0
pixel_courant_sens_vitesse_x	dc.w 0
pixel_courant_vitesse_x	dc.w 0
pixel_courant_sens_vitesse_y	dc.w 0
pixel_courant_vitesse_y	dc.w 0

str	ds.b 9				;utilise par print_value
stat_key	dc.b 0			;utilise par get_key

speedstr dc.b "SPEED :",0
during dc.b "Keys during the simulation :",0
key1 dc.b "ESC ...",0
key2 dc.b "[+] and [-] to change the contrast",0
key3 dc.b "Up and Down to change the speed",0
made1 dc.b "Made by LubnanTI",0
made2 dc.b "yves_c07@yahoo.com",0
pressenter dc.b "Press ENTER",0
_comment   dc.b    "ARTIFICE V1.1",0
        end

;;;;COMMENT SONT FORMES LES TABLEAUX  => 6 octets + 150 = 156 octets/tableau
;	WORD	temps ecoule depuis l'explosion
;	WORD	position initiale sur x
;	WORD	position initiale sur y
;
;;pour chaque pixel => donc faire 10 *	=> 15 * 10 octets = 150 octets
;	WORD	a afficher 1=OUI  0=NON
;	WORD	si vitesse sur l'axe x est -	1=OUI  0=NON
;	WORD	Vitesse sur l'axe x
;	WORD	si vitesse sur l'axe y est -	1=OUI  0=NON
;	WORD	Vitesse sur l'axe y

;;;;Formule pour calculer la position des pixels	avec G = gravite = 2
;	Sur l'axe X
;		si vitesse sur l'axe x est +
;			X = Temps * VitesseX + PositionInitialeX
;		si vitesse sur l'axe x est -
;			X = - Temps * VitesseX + PositionInitialeX
;	Sur l'axe y
;		si vitesse sur l'axe y est +
;			Y = Temps ( G * Temps - VitesseY) + PositionInitialeY
;		si vitesse sur l'axe y est -
;			Y = Temps ( G * Temps + VitesseY) + PositionInitialeY